#include <avr/io.h>
#include <avr/interrupt.h>

// definition of global variable visible to all functions
int c_counter = 2;

// "static" means this variable is visible only within this .C file
static int private_counter = 3;

extern int y; // y is defined outside this source file

void static fun2();

// local function definition, but globally variable 
int fun1() {
    y=y+3;  // access the global variable defined externally
    DDRB = 0xFF;
    PORTB = 0x00;
    
    cli(); // disable interrupts to guarantee that y won't change while being assigned to temp
    int temp = y;
    sei();  // reenable interrupts

    fun2(); // call the private funcion only visible within this source module

    return temp;    // y and temp may have different values if an interrupt occurs here
}

// the "static" declarator essetially makes function private ("non-extern") to a source module
static void fun2() {

    c_counter++;
    private_counter++;

}
